package com.apl;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.bmc.arsys.api.*;
import com.bmc.arsys.pluginsvr.plugins.*;

public class EmailValidatorPlugin extends ARFilterAPIPlugin {

	public void initialize(ARPluginContext context) {
		context.logMessage(ARPluginContext.PLUGIN_LOG_LEVEL_INFO, "A Programming Legacy - Migration Plugin Loaded");
	}

	public void OnEvent(ARPluginContext context,int pEventID) {
	}

	public void terminate(ARPluginContext context) {
	}

	public List<Value> filterAPICall(ARPluginContext context, List<Value> input) {
		String input1 = "";
		String input2 = "";
		String input3 = "";
		String input4 = "";

		if (input.get(0) != null)
			input1 = input.get(0).toString();
		if (input.get(1) != null)
			input2 = input.get(1).toString();
		if (input.get(2) != null)
			input3 = input.get(2).toString();
		if (input.get(3) != null)
			input4 = input.get(3).toString();

		List<Value> output = new ArrayList<Value>();

		//Start the Copy/Paste region

		List<String> valid = new ArrayList<String>();
		List<String> invalid = new ArrayList<String>();

		String emailPattern = 
				"^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*@"
				+ "[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";

		Pattern pattern = Pattern.compile(emailPattern);

		String[] tokenEmail = null;

		tokenEmail = input1.split("[" + input2 + "]");

		for (int i=0; i < tokenEmail.length; i++) {
			String curToken = tokenEmail[i].trim();
			
			if (!curToken.equals("")) {
				Matcher matcher = pattern.matcher(curToken);
				
				if (matcher.matches()) {
					valid.add(curToken);
				} else {
					invalid.add(curToken);
				}
			}
		}
		
		if (input3.equalsIgnoreCase("valid")) {
			String s = "";
			for (String email: valid) {
				s += ", " + email;
			}
			s = s.substring(2, s.length());
			output.add(new Value(s));
		} else if (input3.equalsIgnoreCase("invalid")) {
			String s = "";
			for (String email: invalid) {
				s += ", " + email;
			}
			s = s.substring(2, s.length());
			output.add(new Value(s));
		} else if (input3.equalsIgnoreCase("valid count")) {
			output.add(new Value(valid.size()));
		} else if (input3.equalsIgnoreCase("invalid count")) {
			output.add(new Value(invalid.size()));
		} else if (input3.equalsIgnoreCase("strip not domain")) {
			String s = "";
			for (String email: valid) {
				String[] token = email.split("@");
				if (token[1].equalsIgnoreCase(input4))
					s += ", " + email;
			}
			s = s.substring(2, s.length());
			output.add(new Value(s));
		} else if (input3.equalsIgnoreCase("strip domain")) {
			String s = "";
			for (String email: valid) {
				String[] token = email.split("@");
				if (!token[1].equalsIgnoreCase(input4))
					s += ", " + email;
			}
			s = s.substring(2, s.length());
			output.add(new Value(s));
		}

		//End Copy/Paste Region

		return output;
	}
}
